<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Graham Featherstone - Introduction</title>
    <link href="../../styles.css" rel="stylesheet" />
</head>

<body>
    <header>
        <div class="container">
            <div class="text-container">
                <h1>Graham Featherstone</h1>
                <p>Chemical Engineering Student | Teacher | Enthusiast</p>
            </div>
            <img src="../../Cropped2.jpg" width="200px">
        </div>
    </header>

    <section>
        <h1>Project 3 - Project Management</h1>
        <h2>
            Key Objectives
        </h2>
        <hl>
            <li>Demonstrate how to setup VS code</li>
            <li>Install Git</li>
            <li>Add personal access token to VS code to sync changes with GitLab</li>
            <li>Make changes and troubleshoot syncing issues</li>
            <li>Describe how I created my website</li>
            <li> Optimize the images so that they fit into 1920x1920px rectangle: JPG format with 60-80 percent quality
            </li>
        </hl>
    </section>

    <section>
        <h2>Installing VS Code</h2>
        <p>
            First, ensure that you have registered on GitLab and created your GitLab account. This step will not be
            demonstrated
            as it is assumed that everyone trying to sync their local text editor to GitLab first has a GitLab account.
            After creating
            your GitLab account, download VS code for your specific operating system by visiting
            https://code.visualstudio.com/. Follow the installation
            instructions to install VS code.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 1.jpg" width="1000px">
        </div>
        <h2>
            Installing Git
        </h2>
        <p>
            Now that you have VS code installed, you will need Git to manage your GitLab project and push/pull updates
            from GitLab. To Install
            Git, proceed to https://git-scm.com/ to download the latest Git release.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 2.jpg" width="1000px">
        </div>
        <div class="image-container">
            <img src="Project3Images\Step 3.jpg" width="500px">
        </div>
        <p>
            Once Git is successfully installed, it will act as the communication between your local installation of VS
            code and the code that
            will be published on GitLab. When you open VS code, click on the Source Control tab on the left of the
            screen (Ctrl-Shift-G)
            to begin setting up the VS Code - Git - GitLab communications. It is highlighted in red in the image below.
            If Git was successfully
            installed, you will have two options - Open folder or clone repository.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 4.jpg" width="1000px">
        </div>
        <h2>
            Extension
        </h2>
        <p>
            At this point, you will also need to install a GitLab extension called GitLab WorkFlow
            which allows VS code to access your GitLab account and files.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 5.jpg" width="1000px">
        </div>
        <p>
            Follow the instructions to setup the GitLab workflow extension. I needed to follow the link to the personal
            access token (step 3)
            as I had difficulties with the second step. Follow the rest of the instructions to successfully link your
            GitLab and VS code.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 6.jpg" width="1000px">
        </div>
        <h2> Cloning your repository</h2>
        <p>
            Now that GitLab and VS Code are successfully able to interact, you should be able to clone the repository
            from GitLab and your files should
            show up in the left portion of the screen.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 7.jpg" width="1000px">
        </div>
        <div class="image-container">
            <img src="Project3Images\Step 8.jpg" width="1000px">
        </div>
        <h2> Push/Pull from GitLab -- Finish setting up Git</h2>
        <p>
            You may now make changes to your webpage. Once those changes have been made, go to the same source control
            menu (Ctrl-Shift-G)
            as you used in the previous step. Write a comment in the box at the top and commit the changes to your
            website. Here, I received
            an error that I had not completed the Git setup. No worries, we will troubleshoot this next! Click learn
            more on this error
            message to figure out the problem.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 9.jpg" width="1000px">
        </div>
        <p>
            To push changes to your website, you first need to give Git your user name and your email. Along with every
            push request, Git
            also submits your user information so that you can see who is working on the project and making alterations.
            This is useful for larger
            projects as it allows each user to see what changes other users have made.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 10.jpg" width="1000px">
        </div>
        <p>
            Using the commands provided in the previous image, open GitBash and make the alterations. The commands are:
        </p>
        <ul>
            <li>git config --global user.name "John Doe"</li>
            <li>git config --global user.email johndoe@example.com</li>
        </ul>
        <p>
            Now you will be able to push/pull from GitLab using VS code by using the Source Control tab on the left.
        </p>
    </section>

    <section>
        <h1>
            How I created my website
        </h1>
        <p>
            To create my website, I asked ChatGPT to quickly create a format for a homepage, it output the following
            code. As I had
            used a slightly different query, the code may vary from my original code.
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 11.jpg" width="1000px">
        </div>
        <p>
            Utilizing this initial code, I proceeded to begin alterations to meet the objectives of the first assignment which 
            included uploading an image and bios of myself to the webpage. Following that, I began small optimizations on the 
            home page including the dropdown menu for navigating my website sub-pages. Most of the rest of my time was spent attempting to 
            have the same header and footer sections on each page automatically; this unfortunately failed and I am still working 
            on it.
        </p>
    </section>

    <section>
        <h1>
            Image Optimization using FFMPEG
        </h1>
        <p>
            To begin, I downloaded the most recent stable Windows build of FFMPEG from:
            <a href="https://ffmpeg.org/">https://ffmpeg.org/</a>. 
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 12.jpg" width="1000px">
        </div>
        <p>
            Once installed, I needed to learn how to use FFMPEG on windows. This required a few steps to do which were outlined
            on this webpage: <a href="https://phoenixnap.com/kb/ffmpeg-windows">https://phoenixnap.com/kb/ffmpeg-windows</a>. 
            By adding a path to FFMPEG, I am able to access the FFMPEG program from windows command line after I navigate to the 
            folder where my photos and videos are saved. This is done by using the simple cd (change directory) command in windows 
            command line. Windows command line can be access by holding down (windows key + R) and entering cmd into the box. These 
            commands can also be run using GitBash or Windows Power Shell (Shift + RMB -- Open Windows Powershell) in the file directory.
        </p>
        <p>
            Following the FFMPEG installation and setting up the path (link above) you are now ready to learn how to use FFMPEG 
            using Git Bash, Powershell, or Command line. There will be several commands that you will need to know to compress images
            and videos.  
        </p>
        <li>ffmpeg -i input_file.x output_file.y</li>
        <li>ffmpeg -i input.png -vf scale=w=1920:h=1920:force_original_aspect_ratio=decrease output_1920.jpg</li>
        <li>Further compression with Image Magick magick: input.x -quality 80 output.y </li>
        <p>
            The first command will reduce the file size by approximately 20% (typically). This can also be done manually using the 
            third command. The second command will alter your image to fit inside of a 1920x1920 box while maintaining the 
            original aspect ratio of the image/video. 
        </p>
        <h1>
            ffmpeg -i input_file.x output_file.y
        </h1>
        <p>
            The first command is intended to change one file type to another. As the windows Snipping Tool will capture images in 
            PNG format, I first wanted to convert these into JPG. I converted them into jpg using FFMPEG through GitBash in the folder location (see below image).
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 13.jpg" width="1000px">
        </div>
        <p>
            As you can see from the image, I have successfully converted the PNG image to jpg. This in turn increased by file 
            size from 82 KB to 103 KB.
        </p>
        <h1>
            ffmpeg -i input.png -vf scale=w=1920:h=1920:force_original_aspect_ratio=decrease output_1920.jpg
        </h1>
        <p>
            The second command was used to fit my image within defined constraints: these being 1920x1920. I used the above command (header)
            to maintain the original aspect ratio of the image while constraining it to 1920x1920. This was again done using the FFMPEG program. 
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 14.jpg" width="1000px">
        </div>
        <h1>
            Image compression with Image Magick
        </h1>
        <p>
            It is possible to reduce image quality using a program called Image Magick. Here I noticed something strange. I believe that the image was already
            altered and compressed from the original conversion (PNG to JPG - Resizing), so reducing the quality using Image Magick actually increased
            the final file size. 
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 15.jpg" width="1000px">
        </div>
        <p>
            It was possible to reduce the image size further, but this resulted in a highly blurry image that was unreadable. However, through conversion and resizing, I was able
            to reduce the file size from 82.0 KB to 65.9 KB. 
        </p>
        <div class="image-container">
            <img src="Project3Images\Step 16.jpg" width="1000px">
        </div>
    </section>


</body>

</html>